/*
 * Copyright (C) 2003 BLADOX, s.r.o.  All rights reserved.
 * 
 * This file is part of an example program for Turbo. This example
 * program may be used, distributed and modified without limitation.
 *
 */

#include <config.h>
#include <turbo/turbo.h>

#include <stdlib.h>
#include <string.h>

/* *INDENT-OFF* */

lc_char PROGMEM lc_s1[]={
	LC_EN("Enter text:")
	LC_CZ("Vlozte text:")
	LC_END
};

lc_char PROGMEM lc_On_Display[]={ 
	LC_EN("On Display")
	LC_CZ("Na displej")
	LC_END
};

lc_char PROGMEM lc_Sending_sms[]={ 
	LC_EN("Sending message")
	LC_CZ("Posilam zpravu")
	LC_END
};

lc_char PROGMEM lc_SMS_send_ok[]={ 
	LC_EN("Message sent")
	LC_CZ("Zprava odeslana")
	LC_END
};

lc_char PROGMEM lc_SMS_send_not_ok[]={ 
	LC_EN("Sending was not successful")
	LC_CZ("Zpravu se nepodarilo odeslat")
	LC_END
};

/* *INDENT-ON* */

void on_display ()
{
  u8 *v, *res;
  u8 *text, *ms, *tmp, *q;
  u8 text_len = 0;
  u8 j, i, l;

X_TEXT:
  text = NULL;
  ms = NULL;
  tmp = NULL;

#define MAX_SMS_LEN     200

  res =
    get_input (locale (lc_s1), 0, 160, NULL,
	       Q_GET_INPUT_ALPHABET | Q_GET_INPUT_SMS_PACKED);
  if (res != ENULL && res != NULL)
  {
    j = 0;
    text_len = res[j] - 1;
    j++;			//len

    if (text_len != 0)
    {
      j++;			// coding
      text = malloc (text_len);
    }
    else
      text = malloc (1);	// send no text - empty sms

    if (text == NULL)
      goto X_NO_RAM;

    memcpy (text, res + j, text_len);
  X_MSISDN:
    res = msisdn (NULL);
    if (res == ENULL)
      goto X_END;		// end
    if (res == NULL)
    {
      free (text);
      text = NULL;
      goto X_TEXT;		// back
    }
    ms = msisdncpy (res, MSISDN_ADN, MEM_R);
    if (ms == NULL)
      goto X_END;

    v = malloc (MAX_SMS_LEN);
    if (v == NULL)
      goto X_NO_RAM;

    res =
      send_sms (text, text_len, ms, MSISDN_ADN, 0xF0, 0x00,
		locale (lc_Sending_sms), v);
    i = get_tag (res, T_RESULT);
    if (i != 0)
    {
      i += 2;
      if (res[i] == 0x00)
	res =
	  display_text_raw (locale (lc_SMS_send_ok),
			    Q_DISPLAY_TEXT_HIGH_PRIORITY |
			    Q_DISPLAY_TEXT_DELAY_CLEAR);
      else
	res =
	  display_text_raw (locale (lc_SMS_send_not_ok),
			    Q_DISPLAY_TEXT_HIGH_PRIORITY |
			    Q_DISPLAY_TEXT_DELAY_CLEAR);
    }
    free (v);
  }

X_END:
  free (text);
  free (ms);
  return;
X_NO_RAM:
  free (text);
  free (ms);
  perror (ERR_NO_RAM);
  return;
}

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_INSERT_MENU:
      insert_menu (locale (lc_On_Display));
      break;
    case ACTION_MENU_SELECTION:
      stk_thread (on_display, data);
      break;
    default:
      break;
  }
}
